#include "vectors.h"
#include "kinematics.h"

namespace physics
{
	/////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////// General /////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	const float Kinematics::metersPerPixel = 0.000264583f;		// 1 pixel = 0.000264583 meters
	const float Kinematics::pixelsPerMeter = 3779.5275590551f;	// 1 meter = 3779.5275590551 pixels

	/////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////// One - Dimensional ///////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	float Kinematics::posUM(const float x0, const float v0, const float a, double dt)
	{
		return (float)(x0 + v0 * dt + 0.5f * a * dt * dt);
	}

	void Kinematics::semiImplicitEuler(float& pos, float& vel, const float acc, const double dt)
	{
		vel += (float)(acc * dt);
		pos += (float)(vel * dt);
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////// Two - Dimensional ///////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	void Kinematics::semiImplicitEuler(mathematics::Vector2F& pos, mathematics::Vector2F& vel, const mathematics::Vector2F acc, const double dt)
	{
		vel += acc * dt;
		pos += vel * dt;
	}
}